Public Class DateFilterWithNATreatment
    Implements Infragistics.Win.IEditorDataFilter

    Public Function Convert(ByVal conversionArgs As Infragistics.Win.EditorDataFilterConvertArgs) As Object Implements Infragistics.Win.IEditorDataFilter.Convert

        'AppEntry: Iteration 13: MATHD03 12/17/2008 - Leaving this here for use in troubleshooting
        'Console.WriteLine(String.Concat(conversionArgs.Direction.ToString, " ~ ", conversionArgs.Context.ToString))

        'We need the cell object so we can get to the objects underneth...if we can't get it then we cant handle the conversion
        Dim tmpCell As Infragistics.Win.UltraWinGrid.UltraGridCell
        If TypeOf (conversionArgs.Context) Is Infragistics.Win.UltraWinGrid.UltraGridCell Then
            tmpCell = DirectCast(conversionArgs.Context, Infragistics.Win.UltraWinGrid.UltraGridCell)
            If IsNothing(tmpCell) = False Then

                'We need the ISignatureDate object to know what to display...if we can't get it then we can't handle the conversion
                Dim tmpSigDate As ISignatureDate

                If TypeOf (tmpCell.Row.ListObject) Is ISignatureDate Then

                    tmpSigDate = DirectCast(tmpCell.Row.ListObject, ISignatureDate)

                    If IsNothing(tmpSigDate) = False Then
                        Select Case conversionArgs.Direction
                            Case ConversionDirection.OwnerToEditor
                                conversionArgs.Handled = True
                                Return conversionArgs.Value
                            Case ConversionDirection.EditorToOwner
                                If conversionArgs.Value.ToString = "N/A" Then
                                    conversionArgs.Handled = True
                                    Return CDate(RCIS.Cimax.Common.CIMAX_MIN_DATE)
                                End If

                                conversionArgs.Handled = True
                                Return conversionArgs.Value
                            Case ConversionDirection.EditorToDisplay
                                If tmpCell.Column.Key = "AgentSignatureDate" AndAlso tmpSigDate.IsAgentSignatureRequired = False Then
                                    conversionArgs.Handled = True
                                    Return "N/A"
                                ElseIf tmpCell.Column.Key = "InsuredSignatureDate" AndAlso tmpSigDate.IsInsuredSignatureRequired = False Then
                                    conversionArgs.Handled = True
                                    Return "N/A"
                                ElseIf TypeOf (conversionArgs.Value) Is Date Then

                                    'AppEntry: Iteration 15: MATHD03 01/09/2009 - We need to display an empty string when the date value is CIMAX_MIN_DATE
                                    Dim tmpDate As Date = CDate(conversionArgs.Value)

                                    If tmpDate = CDate(RCIS.Cimax.Common.CIMAX_MIN_DATE) Then
                                        conversionArgs.Handled = True
                                        Return String.Empty
                                    Else
                                        conversionArgs.Handled = True
                                        Return CDate(conversionArgs.Value).ToString("MM/dd/yyyy")
                                    End If
                                Else
                                    conversionArgs.Handled = False
                                    Return conversionArgs.Value
                                End If
                            Case ConversionDirection.DisplayToEditor

                                'AppEntry: Iteration 15: MATHD03 01/09/2009 - If the value is an empty string we need set the date value to CIMAX_MIN_DATE
                                If conversionArgs.Value.ToString = "N/A" OrElse conversionArgs.Value.ToString = String.Empty Then
                                    conversionArgs.Handled = True
                                    Return CDate(RCIS.Cimax.Common.CIMAX_MIN_DATE)
                                Else
                                    If IsDate(conversionArgs.Value) Then
                                        conversionArgs.Handled = True
                                        Return CDate(conversionArgs.Value).ToString
                                    Else
                                        conversionArgs.Handled = True
                                        Return Nothing
                                    End If
                                End If
                        End Select


                    End If

                End If

            End If

        End If

        conversionArgs.Handled = False
        Return conversionArgs.Value

    End Function
End Class
